package edu.harvard.mgh.purcell.gplink.mainGUI;

import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.JFrame;
import javax.swing.JSplitPane;
import javax.swing.UIManager;

import edu.harvard.mgh.purcell.gplink.data.*;
/**
 * An extention of JFrame that contians the main window for this GUI.
 * @author Kathe Todd-Brown
 * 
 */
@SuppressWarnings("serial")
public class MainFrame extends JFrame {

	public static String VS = "0.266";
	
	public Project data;

	public OpView operationsView;

	public LogView logViewer;
	
	public GPLINKMenuBar menuStuff;

	public Object lock = new Object();
	
	public void updateViews() {
		data.updateFiles();
		operationsView.updateView();
		logViewer.update(logViewer.getCurrentFile(), true);
	}

	public void updateViews(boolean forceUpdate) {
		data.updateFiles(forceUpdate);
		operationsView.updateView();
		logViewer.update(logViewer.getCurrentFile(), true);
	}
	
	WindowListener properClosing = new WindowListener() {

		public void windowOpened(WindowEvent e) {}

		public void windowClosing(WindowEvent e) {
			data.closeOldProject();
			System.exit(0);
			
		}

		public void windowClosed(WindowEvent e) {}
		public void windowIconified(WindowEvent e) {}
		public void windowDeiconified(WindowEvent e) {}
		public void windowActivated(WindowEvent e) {}
		public void windowDeactivated(WindowEvent e) {}

	};

	public MainFrame() {
		super("gPLINK");

		data = new Project(null, this);
		operationsView = new OpView(this);
		logViewer = new LogView(this);
		menuStuff = new GPLINKMenuBar(this);
		JSplitPane splitPane = new JSplitPane(JSplitPane.VERTICAL_SPLIT,
                operationsView, logViewer);
		splitPane.setDividerLocation(0.5);
		
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);

		setJMenuBar(menuStuff);
		
		getContentPane().add(splitPane);

		this.addWindowListener(properClosing);
	}
	
	/**
	 * actually generates the main frame gui.
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		try {
	        UIManager.setLookAndFeel(
	        		//UIManager.getCrossPlatformLookAndFeelClassName()
	        		UIManager.getSystemLookAndFeelClassName()
	        		);
	    } catch (Exception e) { 
	    	System.err.println("Couldn't set look and feel, using default: MainFrame.java");
	    }

		
		JFrame f = new MainFrame();
		f.pack();
		f.setVisible(true);

	}

}
